VERSION 5.00
Begin VB.Form Form1 
   Caption         =   "Form1"
   ClientHeight    =   2505
   ClientLeft      =   1140
   ClientTop       =   1515
   ClientWidth     =   4935
   LinkTopic       =   "Form1"
   PaletteMode     =   1  'UseZOrder
   ScaleHeight     =   2505
   ScaleWidth      =   4935
   Begin VB.Frame Frame2 
      Caption         =   "Flags"
      Height          =   1215
      Left            =   0
      TabIndex        =   6
      Top             =   360
      Width           =   4935
      Begin VB.CheckBox chkNoMinutesSeconds 
         Caption         =   "No Minutes/Seconds"
         Height          =   255
         Left            =   240
         TabIndex        =   11
         Top             =   240
         Width           =   2175
      End
      Begin VB.CheckBox chkNoSeconds 
         Caption         =   "No Seconds"
         Height          =   255
         Left            =   240
         TabIndex        =   10
         Top             =   480
         Width           =   2295
      End
      Begin VB.CheckBox chkNoTimeMarker 
         Caption         =   "No Time Marker"
         Height          =   255
         Left            =   2760
         TabIndex        =   9
         Top             =   240
         Width           =   2055
      End
      Begin VB.CheckBox chk24HourFormat 
         Caption         =   "24 Hour Format"
         Height          =   255
         Left            =   2760
         TabIndex        =   8
         Top             =   480
         Width           =   2055
      End
      Begin VB.TextBox txtFormat 
         Height          =   285
         Left            =   1800
         TabIndex        =   7
         Top             =   840
         Width           =   1935
      End
      Begin VB.Label lblFormat 
         Caption         =   "Format"
         Height          =   255
         Left            =   1200
         TabIndex        =   12
         Top             =   840
         Width           =   495
      End
   End
   Begin VB.OptionButton optLocale 
      Caption         =   "System Default"
      Height          =   255
      Index           =   0
      Left            =   720
      TabIndex        =   0
      Tag             =   "&H400"
      Top             =   0
      Width           =   1455
   End
   Begin VB.OptionButton optLocale 
      Caption         =   "User Default"
      Height          =   255
      Index           =   1
      Left            =   2160
      TabIndex        =   1
      Tag             =   "&H800"
      Top             =   0
      Width           =   1335
   End
   Begin VB.OptionButton optLocale 
      Caption         =   "Use Overrides"
      Height          =   255
      Index           =   2
      Left            =   3480
      TabIndex        =   2
      Tag             =   "0"
      Top             =   0
      Width           =   1335
   End
   Begin VB.CommandButton cmdFormat 
      Caption         =   "Format"
      Default         =   -1  'True
      Height          =   375
      Left            =   2040
      TabIndex        =   3
      Top             =   1680
      Width           =   855
   End
   Begin VB.Label Label1 
      AutoSize        =   -1  'True
      Caption         =   "Locale:"
      Height          =   195
      Index           =   6
      Left            =   0
      TabIndex        =   5
      Top             =   0
      Width           =   525
   End
   Begin VB.Label lblResult 
      Height          =   315
      Left            =   0
      TabIndex        =   4
      Top             =   2160
      Width           =   4965
   End
End
Attribute VB_Name = "Form1"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = True
Attribute VB_Exposed = False
Option Explicit

Private Type SYSTEMTIME
    wYear As Integer
    wMonth As Integer
    wDayOfWeek As Integer
    wDay As Integer
    wHour As Integer
    wMinute As Integer
    wSecond As Integer
    wMilliseconds As Integer
End Type

Private Const LOCALE_SYSTEM_DEFAULT = &H400
Private Const LOCALE_USER_DEFAULT = &H800
Private Const LOCALE_NOUSEROVERRIDE = &H80000000
Private Const LOCALE_USE_CP_ACP = &H40000000
Private Const TIME_NOMINUTESORSECONDS = &H1
Private Const TIME_NOSECONDS = &H2
Private Const TIME_NOTIMEMARKER = &H4
Private Const TIME_FORCE24HOURFORMAT = &H8

Private Declare Function GetTimeFormat Lib "kernel32.dll" Alias "GetTimeFormatA" (ByVal Locale As Long, ByVal dwFlags As Long, lpTime As SYSTEMTIME, ByVal lpFormat As Any, ByVal lpTimeStr As String, ByVal cchTime As Long) As Long
Private Declare Sub GetLocalTime Lib "kernel32.dll" (lpSystemTime As SYSTEMTIME)

Private m_Locale As Long

Private Sub chk24HourFormat_Click()
    lblFormat.Enabled = _
        (chkNoMinutesSeconds.Value = vbUnchecked) And _
        (chkNoSeconds.Value = vbUnchecked) And _
        (chkNoTimeMarker.Value = vbUnchecked) And _
        (chk24HourFormat.Value = vbUnchecked)
    txtFormat.Enabled = lblFormat.Enabled
End Sub

Private Sub chkNoSeconds_Click()
    lblFormat.Enabled = _
        (chkNoMinutesSeconds.Value = vbUnchecked) And _
        (chkNoSeconds.Value = vbUnchecked) And _
        (chkNoTimeMarker.Value = vbUnchecked) And _
        (chk24HourFormat.Value = vbUnchecked)
    txtFormat.Enabled = lblFormat.Enabled
End Sub

Private Sub chkNoMinutesSeconds_Click()
    lblFormat.Enabled = _
        (chkNoMinutesSeconds.Value = vbUnchecked) And _
        (chkNoSeconds.Value = vbUnchecked) And _
        (chkNoTimeMarker.Value = vbUnchecked) And _
        (chk24HourFormat.Value = vbUnchecked)
    txtFormat.Enabled = lblFormat.Enabled
End Sub

Private Sub chkNoTimeMarker_Click()
    lblFormat.Enabled = _
        (chkNoMinutesSeconds.Value = vbUnchecked) And _
        (chkNoSeconds.Value = vbUnchecked) And _
        (chkNoTimeMarker.Value = vbUnchecked) And _
        (chk24HourFormat.Value = vbUnchecked)
    txtFormat.Enabled = lblFormat.Enabled
End Sub


' Format the text.
Private Sub cmdFormat_Click()
Dim local_time As SYSTEMTIME

    ' Use the time now.
    GetLocalTime local_time

    ' Format the time.
    lblResult.Caption = _
        FormatTime(local_time, _
            m_Locale, _
            chkNoMinutesSeconds.Value = vbChecked, _
            chkNoSeconds.Value = vbChecked, _
            chkNoTimeMarker.Value = vbChecked, _
            chk24HourFormat.Value = vbChecked)
End Sub

' Format a numeric string.
Private Function FormatTime(system_time As SYSTEMTIME, ByVal locale_id As Long, ByVal no_minutes_seconds As Boolean, ByVal no_seconds As Boolean, ByVal no_time_marker As Boolean, ByVal force_24_hour_format As Boolean) As String
Dim flags As Long
Dim buf As String * 200
Dim buflen As Integer

    flags = 0
    If no_minutes_seconds Then flags = flags Or TIME_NOMINUTESORSECONDS
    If no_seconds Then flags = flags Or TIME_NOSECONDS
    If no_time_marker Then flags = flags Or TIME_NOTIMEMARKER
    If force_24_hour_format Then flags = flags Or TIME_FORCE24HOURFORMAT

    If locale_id = 0 Then
        ' Custom.
        ' See if we need to use a format.
        If (flags = 0) And Len(txtFormat.Text) > 0 Then
            buflen = GetTimeFormat(locale_id, flags, _
                system_time, txtFormat.Text, buf, Len(buf))
        Else
            buflen = GetTimeFormat(locale_id, flags, _
                system_time, ByVal 0&, buf, Len(buf))
        End If
    Else
        ' Locale.
        buflen = GetTimeFormat(locale_id, 0, _
            system_time, ByVal 0&, buf, Len(buf))
    End If

    FormatTime = Left$(buf, buflen)
End Function
Private Sub Form_Load()
    optLocale(0).Value = True
End Sub


Private Sub optLocale_Click(Index As Integer)
    m_Locale = CInt(optLocale(Index).Tag)

Dim enable As Boolean
Dim ctl As Control

    enable = (m_Locale = 0)
    Frame2.Enabled = enable
    For Each ctl In Controls
        If ctl.Container Is Frame2 Then
            ctl.Enabled = enable
        End If
    Next ctl
End Sub

